freeslot("S_PLAY_RINGSPARK1", "S_PLAY_RINGSPARK2", "S_PLAY_RINGSPARK3", "SPR2_RSPF",
"MT_RINGSPARKAURA", "MT_RINGSPARKHITBOX", "S_RINGSPARKAURA", "S_RINGSPARKHITBOX", "SPR_RSPA")

mobjinfo[MT_RINGSPARKAURA] = {
	doomednum = -1,
	spawnstate = S_RINGSPARKAURA,
	spawnhealth = 1000,
	reactiontime = 8,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	mass = 16,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY
}

mobjinfo[MT_RINGSPARKHITBOX] = {
	doomednum = -1,
	spawnstate = S_RINGSPARKHITBOX,
	spawnhealth = 1000,
	reactiontime = 8,
	radius = 48*FRACUNIT,
	height = 50*FRACUNIT,
	mass = 16,
	dispoffset = 1,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_RINGSPARKHITBOX] = {SPR_NULL, A, 1, A_CapeChase, 0, 0, S_RINGSPARKHITBOX}

states[S_RINGSPARKAURA] = {SPR_RSPA, A|FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS30, 8, nil, 1, 4, S_NULL}

states[S_PLAY_RINGSPARK1] = {SPR_PLAY, SPR2_ROLL|FF_SEMIBRIGHT, 5*TICRATE, A_PlaySound, none, 1, S_PLAY_RINGSPARK2}
states[S_PLAY_RINGSPARK2] = {SPR_PLAY, SPR2_RSPF|FF_ANIMATE|FF_FULLBRIGHT, 5*TICRATE, none, sfx_s3k40, 1, S_PLAY_RINGSPARK3}
states[S_PLAY_RINGSPARK3] = {SPR_PLAY, SPR2_RSPF, 1, A_PlaySound, sfx_kc65, 1, S_PLAY_WALK}
 // too lazzy to merge properly
freeslot("MT_MELEEHITBOX","S_MBOX1","S_MBOX2",
"MT_DIGHITBOX","S_DBOX1","S_DBOX2",
"MT_TAILHITBOX","S_TBOX1",
"MT_JABEXPLOADE",
"S_PLAY_K_PUNCHSTART1", "S_PLAY_K_PUNCHSTART2",
"S_PLAY_K_PUNCHACTIVE1", "S_PLAY_K_PUNCHRECOVERY",
"S_JAB_EXPLOADE",
"S_PLAY_KNUXFALL", // just so that way it wont print errors
"SPR_PUCN", "SPR_EJAB",
"MT_SUPERSPINWAVE","S_SUPPERSPIN_WAVE1","S_SUPPERSPIN_WAVE2","S_SUPPERSPIN_WAVE3",
"S_SUPPERSPIN_WALL1","S_SUPPERSPIN_WALL2","S_SUPPERSPIN_WALL3",
"S_SUPPERSPIN_WAVE_ACTIVE","S_SUPPERSPIN_WAVE_END",
"SPR_SPNV", "SPR_SPNW", "SPR_SPNX",
"SPR_SPDV", "SPR_SPDW", "SPR_SPDX"
)

local battle_loaded = false
// 15 startup
states[S_PLAY_K_PUNCHSTART1] = { // start punch 1
	sprite = SPR_PLAY,
	frame = A|SPR2_WALK,
	tics = 7,
	action = none,
	var1 = 0,
	var2 = 3,
	nextstate = S_PLAY_K_PUNCHSTART2
}
states[S_PLAY_K_PUNCHSTART2] = { // start punch 15total
	sprite = SPR_PLAY,
	frame = A|SPR2_WALK,
	tics = 8,
	action = none,
	var1 = 0,
	var2 = 3,
	nextstate = S_PLAY_K_PUNCHACTIVE1
}

states[S_PLAY_K_PUNCHACTIVE1] = { // active 35 total
	sprite = SPR_PUCN,
	frame = A,
	tics = 10,
	action = none,
	var1 = 0,
	var2 = 3,
	nextstate = S_PLAY_K_PUNCHRECOVERY
 }

states[S_PLAY_K_PUNCHRECOVERY] = { //40 total
	sprite = SPR_PLAY,
	frame = A|SPR2_EDGE,
	tics = 15,
	action = none,
	var1 = 0,
	var2 = 3,
	nextstate = S_PLAY_WALK
 }

states[S_JAB_EXPLOADE] = { // punch hit box and effect
	sprite = SPR_EJAB,
	frame = FF_ANIMATE|FF_FULLBRIGHT|FF_TRANS10|A,
	tics = 22,
	action = none,
	var1 = 10,
	var2 = 2,
	nextstate = S_NULL
}

states[S_SUPPERSPIN_WAVE1] = { // front/back effects
	sprite = SPR_SPNV,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 4,
	action = none,
	var1 = 2,
	var2 = 2,
	nextstate = S_SUPPERSPIN_WAVE2
}

states[S_SUPPERSPIN_WAVE2] = { 
	sprite = SPR_SPNW,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	action = none,
	var1 = 6,
	var2 = 1,
	nextstate = S_SUPPERSPIN_WAVE2
}


states[S_SUPPERSPIN_WAVE3] = { 
	sprite = SPR_SPNX,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	action = none,
	var1 = 6,
	var2 = 1,
	nextstate = S_NULL
}

states[S_SUPPERSPIN_WALL1] = { // side  effects
	sprite = SPR_SPDV,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 4,
	action = none,
	var1 = 2,
	var2 = 2,
	nextstate = S_SUPPERSPIN_WALL2
}

states[S_SUPPERSPIN_WALL2] = { // test
	sprite = SPR_SPDW,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	action = none,
	var1 = 6,
	var2 = 1,
	nextstate = S_SUPPERSPIN_WALL2
}


states[S_SUPPERSPIN_WALL3] = { // test
	sprite = SPR_SPDX,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	action = none,
	var1 = 6,
	var2 = 1,
	nextstate = S_NULL
}

states[S_SUPPERSPIN_WAVE_ACTIVE] = { // projectile states
	sprite = SPR_NULL,
	frame = MF2_DONTDRAW|A,
	tics = 700,
	action = none,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_SUPPERSPIN_WAVE_END] = {  
	sprite = SPR_NULL,
	frame = MF2_DONTDRAW|A,
	tics = 7,
	action = none,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}


mobjinfo[MT_MELEEHITBOX].name = "piko hammer"

mobjinfo[MT_MELEEHITBOX] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_MBOX1,
	radius = 20*FRACUNIT,
	height = 32*FRACUNIT,
	damage = 1,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_JABEXPLOADE] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_JAB_EXPLOADE,
	radius = 24*FRACUNIT,
	height = 48*FRACUNIT,
	damage = 1,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SUPERSPINWAVE] = {
	name = "spin wave",
	doomednum = -1,
	spawnhealth = 100,
	spawnstate = S_SUPPERSPIN_WAVE_ACTIVE,
	deathstate = S_SUPPERSPIN_WAVE_END,
	radius = 32*FRACUNIT,
	height = 96*FRACUNIT,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_SCENERY // add |MF_MISSILE latter?
}

//------ do glide after being bumped out of a jump --//
addHook("PlayerThink", function(player)

	if player.superspindunked and (player.mo and player.mo.valid) and P_IsObjectOnGround(player.mo) then
		player.superspindunked = false
	end
	
	if (player.mo and player.mo.valid) and // bug fix
	player.punchthrustedit and player.thrustfactor != skins[player.mo.skin].thrustfactor then 
				player.thrustfactor = skins[player.mo.skin].thrustfactor
				player.punchthrustedit = nil
		end
	
	if(player.mo and player.mo.valid)
	and (player.mo.skin == "knuckles" or player.mo.skin == "amy") then
	local mo = player.mo
		
		if player.pflags & (PF_JUMPED) then
			player.bumpedability = true
			player.amybumphammer = false
		elseif mo.state == S_PLAY_JUMP or mo.state == S_PLAY_FALL or mo.state == S_PLAY_TWINSPIN or mo.state == S_PLAY_KNUXFALL then else
			player.bumpedability = false
		end
		if player.pflags & (PF_GLIDING) and mo.state != S_PLAY_KNUXFALL then // player.bumpedability
			player.bumpedability = false
			player.amybumphammer = false
		end
		
		if not (player.cmd.buttons & BT_JUMP) then
			player.bumpedspintapready = true // should say jump but too lazzy to rename
			player.bumpedspintapping = false
		elseif player.bumpedspintapready then
			player.bumpedspintapping = true
			player.bumpedspintapready = false
		else
			player.bumpedspintapping = false
		end 
		
		if not (player.cmd.buttons & BT_USE) then
			player.bumpedusetapready = true
			player.bumpedusetapping = false
		elseif player.bumpedusetapready then
			player.bumpedusetapping = true
			player.bumpedusetapready = false
		else
			player.bumpedusetapping = false
		end 
		
		if player.bumpedability and (mo.state == S_PLAY_FALL or mo.state == S_PLAY_KNUXFALL) then
			//print(mo.pushtics)
			if (mo.skin == "knuckles") and mo.pushtics < 10 and player.bumpedspintapping 
			and not (player.pflags&PF_THOKKED) then
				if player.gotflag or player.gotcrystal then
				return end
				player.pflags = $|PF_JUMPED
				player.pflags = $| PF_GLIDING
				mo.momz = $/2
				mo.state = S_PLAY_GLIDE 
				player.bumpedability = false
			elseif (mo.skin == "amy") and mo.pushtics > 1 then
				player.amybumphammer = true
			end
		end
	end
	
	//amy hammer hit box //
	if player.mo and player.mo.valid and player.mo.hitbox == nil and (player.mo.frame == 258 or player.mo.frame == 259) and
		 (player.mo.state == S_PLAY_TWINSPIN or player.mo.state == S_PLAY_MELEE) then
			local mo = player.mo
			//mo.hitbox = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MELEEHITBOX)
			mo.hitbox = P_SpawnPlayerMissile(mo, MT_MELEEHITBOX)
			if mo and mo.valid and mo.hitbox != nil and mo.hitbox.valid then
				mo.hitbox.state = S_MBOX1
			end
	end
	
	// alow fang to shoot popgun after pogo
	if(player.mo and player.mo.valid) and player.charability == CA_BOUNCE then
		
		if not (player.cmd.buttons & BT_USE) then
			player.popgusetapready = true
			player.popgusetapping = false
		elseif player.popgusetapready then
			player.popgusetapping = true
			player.popgusetapready = false
		else
			player.popgusetapping = false
		end 
		
		if (player.pflags&PF_THOKKED) and not (player.pflags&PF_BOUNCING)
		and player.mo.state == S_PLAY_FALL and player.popgusetapping and not player.pogostoped then
			player.pflags = $|PF_JUMPED
			player.pflags = $&~PF_THOKKED
			player.airgun = true
			player.pogostoped = true
		end
		if player.pogostoped and player.mo.state != S_PLAY_FALL then
			player.pogostoped = false
		end
	end
end)

addHook("JumpSpecial", function(player)
	if player.charability == CA_BOUNCE and player.pogostoped then
		return true // no repeating tail bounces!
	end
end)

// make fuuny sound if you get dunked into a pit
addHook("MobjDeath", function(mo, inflictor, source, damagetype)

	if mo.player and mo.player.valid and mo.player.superspindunked and (damagetype == DMG_DEATHPIT or damagetype == DMG_CRUSHED)  then
		S_StartSound(nil, sfx_cdpcm2)
		mo.player.superspindunked = false
	else
		mo.player.superspindunked = false
	end
	
end, MT_PLAYER) //---------------------------//

// tumble projectile users if parryed up close
addHook("ShouldDamage", function(mo, inflictor, source, damagetype)
	if source and source.valid and inflictor and inflictor.valid and inflictor!= source and mo.player.guard >= 1 then
		local parrytumblerange = P_GetPlayerHeight(mo.player)*3
		local parrydistance = R_PointToDist2(mo.x, mo.y, source.x, source.y)
		local parryangle = R_PointToAngle2(mo.x, mo.y, source.x, source.y)
		local B = CBW_Battle
		if parrydistance <= parrytumblerange and source.z <= mo.z+parrytumblerange and source.z >= mo.z-parrytumblerange then
			if source.type == MT_PLAYER then
				B.DoPlayerTumble(source.player, 50, parryangle, mo.scale*3, true)
			elseif source.health then
				P_DamageMobj(source, mo, mo)
			end
		end
	end
end, MT_PLAYER) //---------------------------//

//-----when hit into a wall at high speeds do tuble
addHook("MobjMoveBlocked", function(mo,thing,line)
	local knockbackspeed = FixedHypot(mo.momx, mo.momy)/mo.scale
	if knockbackspeed > 15 and mo.state == S_PLAY_PAIN
	and mo. player and mo.player.valid and not mo.player.tumble then
		local B = CBW_Battle
		local tumblerangle = mo.player.drawangle
		local verticalbounce = 4
		if (mo.eflags & MFE_UNDERWATER) then
			verticalbounce = 2
		end
		S_StartSound(mo, sfx_wbreak)
		mo.player.powers[pw_flashing] = 0
		B.DoPlayerTumble(mo.player, 50, tumblerangle, mo.scale*3, true)
		A_ZThrust(mo, verticalbounce, 0)
	end
	
end, MT_PLAYER)//------------//

//-------- spawn paper sprite effects for spin wave------------//
addHook("MobjSpawn", function(mo)
	
	if mo.rightwaves == nil and mo.target and mo.target.valid then
	S_StartSound(mo, sfx_s3k57)
	mo.centerwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.centerwaves.state = S_SUPPERSPIN_WAVE1
	mo.centerwaves.angle = mo.angle
	mo.centerwaves.target = mo
	mo.centerwaves.color = SKINCOLOR_SKY
	mo.rightwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.rightwaves.state = S_SUPPERSPIN_WALL1
	mo.rightwaves.angle = mo.angle
	mo.rightwaves.target = mo
	mo.rightwaves.color = SKINCOLOR_SKY
	mo.leftwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.leftwaves.state = S_SUPPERSPIN_WALL1
	mo.leftwaves.angle = mo.angle
	mo.leftwaves.target = mo
	mo.leftwaves.color = SKINCOLOR_SKY
	end
end, MT_SUPERSPINWAVE)

//-------- spin wave thinker ------------//
addHook("MobjThinker", function(mo)

	if mo.rightwaves == nil and mo.target and mo.target.valid then
	S_StartSound(mo, sfx_s3k57)
	mo.centerwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.centerwaves.state = S_SUPPERSPIN_WAVE1
	mo.centerwaves.angle = mo.angle
	mo.centerwaves.target = mo
	mo.centerwaves.color = SKINCOLOR_SKY
	mo.rightwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.rightwaves.state = S_SUPPERSPIN_WALL1
	mo.rightwaves.angle = mo.angle
	mo.rightwaves.target = mo
	mo.rightwaves.color = SKINCOLOR_SKY
	mo.leftwaves = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
	mo.leftwaves.state = S_SUPPERSPIN_WALL1
	mo.leftwaves.angle = mo.angle
	mo.leftwaves.target = mo
	mo.leftwaves.color = SKINCOLOR_SKY
	end

		// prevent spawning into higher sectors!
	if mo.target and mo.target.valid and mo.spawntime <= 2  then
	local gravityflip = P_MobjFlip(mo)
	local ihatereversegravity = mo.target.z+mo.target.height
		if (gravityflip < 0 and mo.z+mo.height < ihatereversegravity) or (gravityflip > 0 and mo.z > ihatereversegravity) then
			print(gravityflip)
			P_RemoveMobj(mo)
			return
		end
	mo.spawntime = $+1
	elseif mo.target and mo.target.valid and mo.spawntime > 2 and mo.spawntime < 5  then
		mo.spawntime = 5
		P_Thrust(mo,mo.angle,mo.startingspeed)
		mo.flags = $|MF_MISSILE
	else
		mo.spawntime = $+1
	end
				
 if mo and mo.valid and mo.state == S_SUPPERSPIN_WAVE_ACTIVE  then
	mo.friction = 1*FRACUNIT

	local moveingspeed = FixedHypot(mo.momx, mo.momy)
	local forwardoffset = 20
	if mo.centerwaves and mo.centerwaves.valid and mo and mo.valid then
		local frontoffset = mo.radius/FRACUNIT
		A_CapeChase(mo.centerwaves, (0 * 65536)+0, (frontoffset * 65536)+0)
		mo.centerwaves.angle = (mo.angle-ANGLE_90)
		mo.centerwaves.color = mo.color
	end
	if mo.rightwaves and mo.rightwaves.valid and mo and mo.valid then
		local rightoffset = 20
		A_CapeChase(mo.rightwaves, (0 * 65536)+0, (forwardoffset * 65536)+rightoffset)
		mo.rightwaves.angle = mo.angle+ANG30
		mo.rightwaves.color = mo.color
	end
	if mo.leftwaves and mo.leftwaves.valid and mo and mo.valid then
		local leftoffset = -20
		A_CapeChase(mo.leftwaves, (0 * 65536)+0, (forwardoffset * 65536)+leftoffset)
		mo.leftwaves.angle = mo.angle-ANG30
		mo.leftwaves.color = mo.color
	end
	
	if moveingspeed < mo.startingspeed/2 and mo.spawntime >= 10 then
		P_KillMobj(mo, mo)
	end
	if mo.spawntime > 1*TICRATE and mo.spawntime < 50*TICRATE then
		P_KillMobj(mo, mo)
		mo.spawntime = 99*TICRATE
	end
 end
end, MT_SUPERSPINWAVE)

addHook("MobjMoveBlocked", function(mo,thing,line)
	if mo and mo.valid then
		P_KillMobj(mo, mo)
	end
end, MT_SUPERSPINWAVE)

// make paper sprites play death animation //
addHook("MobjDeath", function(mo, inflictor, source, damagetype)
 if mo and mo.valid then
	if mo.centerwaves and mo.centerwaves.valid then
			mo.centerwaves.state = S_SUPPERSPIN_WAVE3
	end
	if mo.rightwaves and mo.rightwaves.valid then
			mo.rightwaves.state = S_SUPPERSPIN_WALL3
	end
	if mo.leftwaves and mo.leftwaves.valid then
			mo.leftwaves.state = S_SUPPERSPIN_WALL3
	end
 end
end, MT_SUPERSPINWAVE)

addHook("MobjRemoved", function(mo) // remove effects too
	if mo and mo.valid then
		if mo.centerwaves and mo.centerwaves.valid then
			P_RemoveMobj(mo.centerwaves)
			P_RemoveMobj(mo.rightwaves)
			P_RemoveMobj(mo.leftwaves)
			mo.centerwaves = false
			mo.rightwaves = false
			mo.leftwaves = false
		end
	end
end, MT_SUPERSPINWAVE)

addHook("MobjDamage", function(mo, inflictor, source, damage, damagetype) //spin wave make hit sound

	if inflictor and inflictor.valid and inflictor.type == MT_SUPERSPINWAVE then
	if mo.player and mo.player.valid and mo.player.guard >= 1 then else
		S_StartSound(mo, sfx_kc40)
		end
	end

end, MT_NULL)

local function AmyBumpHammerTime(player) // hammer after a bump
local mo = player.mo
	if(mo and mo.valid) and
	(mo.skin == "amy") and not P_IsObjectOnGround(player.mo) and (mo.state == S_PLAY_FALL or mo.state == S_PLAY_JUMP) and
	player.amybumphammer and (player.bumpedspintapping or player.bumpedusetapping) then
		mo.state = S_PLAY_TWINSPIN 
		S_StartSound(mo, sfx_s3k42)
		player.pflags = $|PF_THOKKED
		player.amybumphammer = false
	end
end
addHook("JumpSpecial", AmyBumpHammerTime)
addHook("SpinSpecial", AmyBumpHammerTime)

//-----fang curve the bullet--------//
addHook("MobjThinker", function(mo)

if mo.curveonce == nil then
	mo.curveonce = 0
end
// S_PLAY_FIRE_FINISH  S_PLAY_FIRE  and mo.flags2~=MF2_TWOD
if mo.target and mo.target.valid and mo.target.type == MT_PLAYER and mo.sprite == SPR_CORK then
	local player = mo.target.player
	if mo.curveonce < 3 then
		local curvespd = FixedMul(mo.scale, (5*FRACUNIT)/((mo.eflags & MFE_UNDERWATER) and 2 or 1))
			if player.cmd.forwardmove < 0 and (mo.target.state == S_PLAY_FIRE or mo.target.state == 2633) then // arc curve 
				P_Thrust(mo, (mo.angle), -curvespd)
				P_SetObjectMomZ(mo, (5*FRACUNIT), true)
				mo.flags = $&~(MF_NOGRAVITY)
				mo.curveonce = 3
			end
			if mo.target and mo.target.flags2&MF2_TWOD then
			// do nothing
			else
				if player.cmd.sidemove > 0 and (mo.target.state == S_PLAY_FIRE or mo.target.state == 2633) then // right curve 
					P_Thrust(mo, (mo.angle-ANGLE_90), curvespd*2)
					mo.curveonce = 3
				elseif player.cmd.sidemove < 0 and (mo.target.state == S_PLAY_FIRE or mo.target.state == 2633) then // left curve
					P_Thrust(mo, (mo.angle+ANGLE_90), curvespd*2)
					mo.curveonce = 3
				end
			end
		end
	mo.curveonce = $+1 //only have few frames to input it
	//----------------spawn fire trail if player has a eleshield--//
	if mo.firetime == nil then
		mo.firetime = 0
	end
	if (player.powers[pw_shield] == SH_ELEMENTAL) and mo.firetime <= 12 then // only spawn a few flames
	
			mo.firetrail = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINFIRE)
			mo.firetrail.flags = 1081360
			mo.firetrail.target = mo.target
			mo.firetrail.time = 0 
			mo.firetime = $+1
			if(gametype > 0)
			mo.firetrail.color = player.skincolor
			mo.firetrail.state = 983
			end
	end
end

end, MT_CORK)//-------------------------------------------------------------------------------//

local function DropFireHearts(mo) //----- have Amys hearts drop fire------//
	if mo.target and mo.target.valid and mo.target.type == MT_PLAYER then
	local player = mo.target.player
		if (player.powers[pw_shield] == SH_ELEMENTAL) and mo.fireonce == nil then 
		mo.fireonce = true
		elseif mo.valid and mo.fireonce == nil then
		mo.fireonce = false
		end
		
		if mo.target and mo.valid and mo.sprite != SPR_LHRT and mo.firetrail == nil and mo.fireonce == true and (player.powers[pw_shield] == SH_ELEMENTAL) then
			mo.firetrail = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINFIRE)
			mo.firetrail.flags = 1081360
			mo.firetrail.target = mo.target
			mo.firetrail.time = 0 
			if(gametype > 0)
			mo.firetrail.color = player.skincolor
			mo.firetrail.state = 983
			end
		end
	end
end

addHook("MobjThinker", DropFireHearts, MT_PIKOWAVEHEART)
addHook("MobjThinker", DropFireHearts, MT_LHRT)

//----add a custom timer to make the firetrail from the cork dissapear
addHook("MobjThinker", function(mo)

	if mo.time != nil then
	mo.time = $+1
		if mo.time > 6*TICRATE then
		mo.state = S_NULL 
		end
	end
	
	 if(gametype > 2) and  mo.valid and mo and mo.state <= 978 then
			mo.state = S_NULL  // fix ring of spinfire bug
	end
end, MT_SPINFIRE)

addHook("MobjThinker", function(mo) // punch explosion hitbox code

	if mo.target and mo.target.valid then
		local horadd = (mo.target.radius*3)/FRACUNIT
		local sideadd = 0
		if mo.target.state == S_PLAY_K_PUNCHACTIVE1 and not mo.noactivetime then // follow player
			A_CapeChase(mo, (0 * 65536)+0, (horadd * 65536)+sideadd)
		elseif mo.target.state == S_PLAY_K_PUNCHRECOVERY then
			mo.noactivetime = true // act like an effect now rather then a hitbox
		elseif not mo.noactivetime and mo.target.state >= S_PLAY_DASH then
			P_RemoveMobj(mo)
		end
	else
		P_RemoveMobj(mo)
	end
end, MT_JABEXPLOADE)

states[S_MBOX1] = {SPR_NULL, 0|FF_FULLBRIGHT, 1, A_CapeChase, 5*FRACUNIT, 30*FRACUNIT, S_MBOX2}
states[S_MBOX2] = {SPR_NULL, 0|FF_FULLBRIGHT, 1, A_CapeChase, 5*FRACUNIT, 30*FRACUNIT, S_MBOX1}

//---------------------------------------------------------------//
local function SpinWaveObjCollide(mo, mobj)
	if mobj and mobj.valid and (mobj.flags & MF_SOLID) then
		if not (mo.z+(1*FRACUNIT) >= mobj.z+mobj.height)
		and not(mobj.z+(1*FRACUNIT) >= mo.z+mo.height) then
		if (mobj.type == MT_PLAYER and mobj.player.powers[pw_flashing]) then return false end
		if (mobj.flags & MF_MONITOR) or (mobj.type == MT_PLAYER) then return end
		P_KillMobj(mo, mo)
		end
	end
end

local function HitBoxCollide(boxhit, mobj)
local B = CBW_Battle
if boxhit.noactivetime then
 return false end
local boxplayer = boxhit.target.player
local moveingspeed = FixedHypot(boxhit.target.momx, boxhit.target.momy)/2
local launchsped = 0
local airpush = 0
local hitsound = 0
local hammerhit = false
local superbuster = false
local explosivepunch = false
local attackpushback = 2*FRACUNIT
if mobj.weight and mobj.weight > 0 then
	attackpushback = $+mobj.weight
end
attackpushback = FixedMul(boxhit.scale, ($)/((boxhit.eflags & MFE_UNDERWATER) and 2 or 1))
if boxhit.type == MT_MELEEHITBOX then // set properties of the hitboxes
 launchsped = FixedMul(boxhit.scale, (7*FRACUNIT)/((boxhit.eflags & MFE_UNDERWATER) and 2 or 1))
 airpush = 2
 hitsound  = sfx_pstop
 hammerhit = true
elseif boxhit.type == MT_DIGHITBOX then
 launchsped = FixedMul(boxhit.scale, (5*FRACUNIT)/((boxhit.eflags & MFE_UNDERWATER) and 2 or 1))
 airpush = 7
 hitsound = sfx_hit00
 superbuster = true
elseif boxhit.type == MT_JABEXPLOADE then
 launchsped = FixedMul(boxhit.scale, (25*FRACUNIT)/((boxhit.eflags & MFE_UNDERWATER) and 2 or 1))
 airpush = 2
 hitsound = sfx_pstop
 explosivepunch = true
elseif boxhit.type == MT_TAILHITBOX then
 launchsped = FixedMul(boxhit.scale, (7*FRACUNIT)/((boxhit.eflags & MFE_UNDERWATER) and 2 or 1))
 airpush = 2
 hitsound  = sfx_hit02
end
	if not (boxhit.z+(1*FRACUNIT) >= mobj.z+mobj.height)
	and not(mobj.z+(1*FRACUNIT) >= boxhit.z+boxhit.height)
		if (mobj.valid and mobj.health and mobj.flags & (MF_ENEMY|MF_BOSS))
			boxplayer.pflags = $&~PF_THOKKED
			P_DamageMobj(mobj, boxhit.target, boxhit.target) // use the targets attack properties
			if explosivepunch == true then // enemys get pushed too
				P_Thrust(mobj, boxhit.angle, launchsped)
			end
		end

		if (mobj.valid and mobj.health and mobj.type == MT_PLAYER and mobj != boxhit.target and 
		(CV_FindVar("friendlyfire").value or mobj.player.ctfteam != boxplayer.ctfteam or not (gametyperules & GTR_TEAMS))
		and not mobj.player.powers[pw_flashing]
			and (mobj.type ~= MT_PLAYER or not (gametyperules & GTR_FRIENDLY) and gametype ~= GT_RACE and gametype ~= GT_COMPETITION))
			if hammerhit == true then // allow amy to swing once more
				boxplayer.pflags = $&~PF_THOKKED
			end
			if explosivepunch and mobj.player.guard != nil and mobj.player.guard >= 1 then // cant parry this punch!
				boxhit.noactivetime = true // cant hit anything else!
				B.DoPlayerTumble(mobj.player, 50, boxhit.angle, boxhit.scale*5, true)
				A_ZThrust(mobj, airpush*4, 0)
				mobj.player.powers[pw_flashing] = 10
				boxhit.target.momx = $/2
				boxhit.target.momy = $/2
				S_StartSound(mobj, sfx_wbreak)
				local hiteffect = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
				hiteffect.state = S_BCEBOOM
				hiteffect.colorized = true
				hiteffect.color = SKINCOLOR_ROSY
				P_Thrust(boxhit.target, (boxhit.angle+ANGLE_180),attackpushback*3) // push back attacker too
				return
			end
			P_DamageMobj(mobj, boxhit.target, boxhit.target) // use the targets attack properties
			if (mobj.player.guard != nil and mobj.player.guard < 1 and mobj.state != S_PLAY_DEAD)
				if superbuster then // dig extra
					mobj.player.powers[pw_super] = 0
					mobj.player.powers[pw_invulnerability] = 0 // hit players out of super and invun... because why not?
					mobj.player.powers[pw_sneakers] = 0
				end
				local hiteffect = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_THOK)
				hiteffect.state = S_BCEBOOM
				hiteffect.colorized = true
				hiteffect.color = SKINCOLOR_WHITE
				boxhit.target.pushtics = 1
				mobj.pushtics = 1 
				mobj.pushed = boxhit.target
				boxhit.target.pushed = nil // dont bump after getting hit?
				S_StartSound(mobj, hitsound)
				P_Thrust(mobj, boxhit.angle, launchsped+moveingspeed)
				A_ZThrust(mobj, airpush, 0)
			end
			P_Thrust(boxhit.target, (boxhit.angle+ANGLE_180),attackpushback) // push back attacker too
		end
		if (mobj.valid and mobj.health and mobj.flags & MF_MONITOR)
			boxplayer.pflags = $&~PF_THOKKED
			P_KillMobj(mobj, boxhit, boxhit.target)
	//		P_SetObjectMomZ(boxhit.target, boxhit.target.momz-boxhit.target.momz*2)
			end
	else
		return nil
	end
end

addHook("MobjMoveCollide", HitBoxCollide, MT_MELEEHITBOX)
addHook("MobjCollide", HitBoxCollide, MT_MELEEHITBOX)

addHook("MobjMoveCollide", HitBoxCollide, MT_DIGHITBOX)
addHook("MobjCollide", HitBoxCollide, MT_DIGHITBOX)

addHook("MobjMoveCollide", HitBoxCollide, MT_JABEXPLOADE)
addHook("MobjCollide", HitBoxCollide, MT_JABEXPLOADE)

addHook("MobjMoveCollide", HitBoxCollide, MT_TAILHITBOX)
addHook("MobjCollide", HitBoxCollide, MT_TAILHITBOX)

addHook("MobjMoveCollide", SpinWaveObjCollide, MT_SUPERSPINWAVE)
addHook("MobjCollide", SpinWaveObjCollide, MT_SUPERSPINWAVE)
//-------------------------------------------------------------------------------//
addHook("MobjThinker", function(mo)

	if mo.target and mo.target.valid then
		local target = mo.target
		if (target.state == S_PLAY_TWINSPIN or target.state == S_PLAY_MELEE or target.state == S_PLAY_MELEE_FINISH)
		and target.frame <= 4099 then
		else
		P_RemoveMobj(mo)
		end
	
	end

end, MT_MELEEHITBOX)

addHook("MobjRemoved", function(mo)
	if mo.target and mo.target.valid then
		mo.target.hitbox = nil
	end
end, MT_MELEEHITBOX)

// add squish to explosive punch 
local function PunchThicc(p) // origanal code by NeonSRB2 
 if p.mo and p.mo.valid then
	if p.jt == nil then
		p.jt = 0
		p.jp = false
		p.sp = false
		p.tk = false
		p.tr = false
	end
	if p.jt > 0 then
		p.jt = p.jt - 1
	end
	if p.jt < 0 then
		p.jt = p.jt + 1
	end

	if p.mo.state == S_PLAY_K_PUNCHACTIVE1 and p.jt == 0 and p.jp == false then
		p.jt = 7
		p.jp = true
	elseif p.mo.state != S_PLAY_K_PUNCHACTIVE1 then
		p.jp = false
	end
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 30
	p.mo.spriteyscale = p.maths + FRACUNIT
	
	//p.maths = p.jt*p.spinheight
	//if p.mo.state != S_PLAY_ROLL then
		p.maths = p.jt*p.height
	//end
	p.maths = p.maths / 60
	p.mo.spriteyoffset = -1*p.maths
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 20
	p.maths = p.maths*-1
	p.mo.spritexscale = p.maths + FRACUNIT
 end
end
addHook("PlayerThink", PunchThicc)